<?php
function getBaseURL(){
	$base=(empty($_SERVER["HTTPS"]) ? "http://" : "https://") . $_SERVER["HTTP_HOST"] . $_SERVER["REQUEST_URI"];
	$w=explode('/', $base);
	array_pop($w);
	$base=implode('/', $w);
	return $base;
}
function getDFiles($targetDir){
	if( empty($targetDir) ){
		return array();
	}
	if( substr($targetDir,-1)!='/' ){
        $targetDir.='/';
    }
    $linkExt = array('txt','php','html','htm','js','css','scss','map','jpg','jpeg','png','bmp','gif','ico','swf','json','xml','rss','pdf','ai','psd','fla','zip','lzh','rar','tar','tar.gz');
    $tmp     = array();
    $pDir    = opendir($targetDir);

    $base    = getBaseURL();
	while( false !== ( $fileName = readdir($pDir) ) ){

		$fileNameSJIS = mb_convert_encoding($fileName, 'UTF-8', 'SJIS');

		if($fileName === '.' || $fileName === '..'){
			continue;
		}

		$path = $targetDir . $fileNameSJIS;
		if(!is_readable($path)){
			$path = $targetDir . $fileName;
			if(!is_readable($path)){
				continue;
			}
		}
		$etmp = explode('.', $fileName);
		$ext  = strtolower(array_pop($etmp));
		$dir  = is_dir($path);
		$w    = array('dir'=>$dir, 'name'=>$fileName, 'fullpath'=>$base . str_replace('./', '/', $path), 'path'=>$path, 'readme'=>'' );
		$w['link'] = !$dir && in_array($ext, $linkExt);
		
		if($dir && file_exists($path.DIRECTORY_SEPARATOR.'readme.txt')){
			$w['readme'] = file_get_contents($path.DIRECTORY_SEPARATOR.'readme.txt');
			$readme_tmp = explode("\n", $w['readme']);
			$readme_tmp = array_shift($readme_tmp);
			if(trim($readme_tmp) == 'disabled'){
				continue;
			}
		}
  		$tmp[]=$w;
	}
	closedir( $pDir );
	usort($tmp, "sortDFiles");
    return $tmp;
}
function sortDFiles($a,$b){
	if(!isset($a['dir']) && !isset($b['dir'])){
		return 0;
	}elseif(isset($a['dir']) && !isset($b['dir'])){
		return -1;
	}elseif(!isset($a['dir']) && isset($b['dir'])){
		return 1;
	}
	if( $a['dir'] && !$b['dir'] ){
		return -1;
	}
	if( !$a['dir'] && $b['dir'] ){
		return 1;
	}
	if( $a['name'] > $b['name'] ){
		return 1;
	}
	if( $a['name'] < $b['name'] ){
		return -1;
	}
	return 0;
}
function error_handler1($errno, $errstr, $errfile, $errline, $errcontext){
	header("Content-Type: application/json; charset=utf-8");
	echo json_encode( array() );
	exit;
}
if(!empty($_POST['cmd'])){
	switch ($_POST['cmd']) {
		case 'getDFiles':
			set_error_handler('error_handler1', E_ALL);
			$resultData = getDFiles( $_POST['target'] );
			header("Content-Type: application/json; charset=utf-8");
			echo json_encode( $resultData );
			exit;
			break;

		default:
			break;
	}
}else if(!empty($_GET['cmd'])){
	switch ($_GET['cmd']) {
		case 'download':
			header("Content-Disposition: inline; filename=\"".basename($_GET['target'])."\"");
	    	header("Content-Length: ".filesize($_GET['target']));
	    	header("Content-Type: application/octet-stream");
	    	readfile( $_GET['target'] );
			exit;
			break;

		default:
			break;
	}
}

?>
<!DOCTYPE html>
<html>
<head>
<meta http-equiv="Content-Type"        content="text/html; charset=utf-8">
<meta http-equiv="Content-Language"    content="ja">
<meta http-equiv="Content-Script-Type" content="text/javascript">
<meta http-equiv="Content-Style-Type"  content="text/css">
<meta name      ="description"         content="">
<meta name      ="keywords"            content="">
<meta name      ="copyright"           content="">
<title>File Viewer</title>
<link href="https://maxcdn.bootstrapcdn.com/bootstrap/3.3.7/css/bootstrap.min.css" rel="stylesheet">
<script src="https://code.jquery.com/jquery-1.12.4.min.js" integrity="sha256-ZosEbRLbNQzLpnKIkEdrPv7lOy9C27hHQ+Xp8a4MxAQ=" crossorigin="anonymous"></script>
<script>
$(function(){

	//---------------------- loading -------------------------
	var setupLoadingSpin=function( $target ){
		$parent=$target.parent();
		$parent.find('.dirClose').after('<div class="loading">┏</div>');
		setTimeout4Loading( $target );
	};
	var setTimeout4Loading=function( $target ){
		$parent=$target.parent();
		if( $parent.find('.loading').length < 1 ){
			return;
		}
		setTimeout(function(){
			if( $parent.find('.loading').length < 1 ){
				return;
			}
			//$parent.find('.loading').html( ( $parent.find('.loading').html()=='□' )? '◇':'□' );
			switch( $parent.find('.loading').html() ){
				case '┏':
				$parent.find('.loading').html('┓');
				break;

				case '┓':
				$parent.find('.loading').html('┛');
				break;

				case '┛':
				$parent.find('.loading').html('┗');
				break;

				case '┗':
				$parent.find('.loading').html('┏');
				break;
			}
			setTimeout4Loading( $target );
		},100);
	};
	var removeLoadingSpin=function( $target ){
		$parent=$target.parent();
		$parent.find('.loading').remove();
	};

	//---------------------- debug -------------------------
	var getPropertyString=function(target){
		var result="";
		for(var str in target){
			result+=str+" : "+target[str]+"\n";
			if(typeof target[str] =='object'){
				result+=getPropertyString(target[str]);
			}
		}
		return result;
	};
	//getPropertyStringで得たstringをalert
	var showInfo=function(target){
		alert( getPropertyString(target) );
	};
	var showResultWithData=function(id,data){
		if( typeof data == 'object' ){
			showResult( id, getPropertyString(data) );
			return;
		}
		showResult( id, data );
	};
	var showResult=function(id,str){
		$('#'+id).parents('.areaBox').find('.result textarea').val(str);
	};
	var resetResult=function(id){
		$('#'+id).parents('.areaBox').find('.result textarea').val('');
	};

	var PHP_FILE_NAME="<?php $t = preg_split("/\\\\|\//",__FILE__);echo array_pop($t); ?>";

	var getFileListHtml=function(json, nextCnt){
		var i;
		var html='';

		if(nextCnt > 0){
			html+='<ul class="borderL">';
		}else{
			html+='<ul>';
		}

		for(i=0;i<json.length;i++){
			html+='<li>';
				if( json[i].dir ){
					html+='<span class="dirLeft">'+ ((i<json.length-1)?'├':'└') +'</span>';
					html+='<a class="dirOpen" href="#">+</a>';
					html+='<a class="dirClose" href="#">-</a>';
				}else{
					html+='<span class="fileLeft">'+ ((i<json.length-1)?'├':'└') +'</span>';
				}
				html+='<span class="fileName'+((json[i].link)?' hasLink':'')+'">';
				if( json[i].link ){
					html+='<a href="'+json[i].path+'" target="_blank">';
					if(/^.*\.(jpg|JPG|jpeg|JPEG|png|PNG|gif|GIF|ico|ICO)$/.test(json[i].name)){
						html+='<span class="glyphicon glyphicon-picture"></span>&nbsp;';
					}else if(/^.*\.(mov|MOV|mpg|MPG|mpeg|MPEG|mp4|MP4|ogv|OGV|webm|WEBM)$/.test(json[i].name)){
						html+='<span class="glyphicon glyphicon-film"></span>&nbsp;';
					}else{
						html+='<span class="glyphicon glyphicon-file"></span>&nbsp;';
					}
					html+=json[i].name+'</a>';
				}else{
					html+=json[i].name;
				}
				html+='</span>';
				if(json[i].readme != ''){
					html+='<div class="readme"><div class="readme-inner"><div class="readme-inner-inner"><div class="readme-title">readme.txt</div>'+json[i].readme.replace(/\n/g,'<br>')+'</div></div></div>';
				}

				if( !json[i].dir ){
					html+='<a class="download" href="'+PHP_FILE_NAME+'?cmd=download&target='+encodeURIComponent(json[i].path)+'">Download</a>';
				}
			html+='</li>';
		}
		html+='</ul>';
		if(nextCnt > 0){
			html+='</ul>';
		}
		return html;
	};
	var switchOpenClose=function($this, open){
		$parent=$this.parent();
		$parent.removeClass('is_open');
		if(!open){
			$parent.find('.dirOpen').css({'display':'inline-block'})
			$parent.find('.dirClose').hide();
		}else{
			$parent.addClass('is_open');
			$parent.find('.dirClose').css({'display':'inline-block'})
			$parent.find('.dirOpen').hide();
		}
	};
	var hideOpenClose=function($this){
		$parent=$this.parent();
		$parent.find('.dirOpen,.dirClose').hide();
	};
	var initOpenCloseButton=function(_$target){
		$target=(_$target) ? _$target.find( '.dirOpen' ) : $('.dirOpen');
		$target.click(function(){
			var $me=$(this);
			var $parent=$(this).parent();
			var $next=$parent.next();
			hideOpenClose( $me );
			setupLoadingSpin( $me );

			var targetDirs=[];
			$(this).parents('li').each(function(){
				targetDirs.push( $(this).find('.fileName').html() );
			});
			var first=targetDirs.pop();
			var targetDir=first+targetDirs.reverse().join('/');
			var data={'cmd':'getDFiles','target':targetDir};
			$.ajax({
				url:PHP_FILE_NAME,
				type:'POST',
				dataType:'json',
				data:data,
				success:function(json){
					switchOpenClose( $me, true );
					removeLoadingSpin( $me );
					$parent.append( getFileListHtml(json, $next.length ) );
					initOpenCloseButton( $parent.find('ul') );
				}
			});

			return false;
		});
		$target=(_$target) ? _$target.find('.dirClose') : $('.dirClose');
		$target.click(function(){
			switchOpenClose( $(this), false );
			$parent.find('ul').remove();

			return false;
		});
	};
	initOpenCloseButton();
	$('.dirOpen').eq(0).trigger('click');

});
</script>
<style type="text/css">
<!--
body{
	margin: 0px;
	padding: 0px;
}
ul{
	padding-left: 25px;
	margin:0;
	list-style-type:none;
}
ul.borderL{
	border-left: 1px solid #000;
}
#mainView > ul{
	padding: 0px;
}
ul li{
	padding: 1px 0px;
}
#wrapper{

}
#main{
	width: 1000px;
	margin: 0 auto;
}
.roundbox{
	background-color: #fafafa;
	padding: 8px 14px;
	margin: 8px;
	border: 1px solid #ddd;
    -webkit-border-radius: 5px;
       -moz-border-radius: 5px;
            border-radius: 5px;
}
.round-bottom{
    -webkit-border-radius:0 0 5px 5px;
       -moz-border-radius:0 0 5px 5px;
            border-radius:0 0 5px 5px;
}
.dirOpen,
.dirClose,
.loading{
	display: inline-block;
	_display:inline;
	_zoom:1;
	width: 24px;
	height: 24px;
	text-align: center;
	vertical-align: top;
	border: 1px dotted #cccccc;
    -webkit-border-radius: 5px;
       -moz-border-radius: 5px;
            border-radius: 5px;
}
.loading{
	font-size: 12px;
}
.download{
	display: inline-block;
	_display:inline;
	_zoom:1;
	padding: 0 5px;
	margin-left: 10px;
	height: 24px;
	text-align: center;
	vertical-align: top;
	border: 1px dotted #cccccc;
    -webkit-border-radius: 5px;
       -moz-border-radius: 5px;
            border-radius: 5px;
}
.dirClose{
	display: none;
}
.dirLeft{
	padding: 2px 5px;
	margin-left: -10px;
}
.fileLeft{
	padding: 2px 5px;
	margin-left: -10px;
}
.readme{
	border-left: 1px solid #000;
}
.is_open > .readme > .readme-inner{
	border-left: 1px solid #000;
}
.readme-inner{
	margin-left: 25px;
	padding-bottom: 10px;
}
.readme-inner-inner{
	/*border-left: 1px solid #000;*/
	position: relative;
	margin-left: 5px;
	padding: 5px 10px;
	padding-top:18px;
	border: 1px solid #ccc;
	background-color: #fafafa;
    -webkit-border-radius: 5px;
       -moz-border-radius: 5px;
            border-radius: 5px;
}
.readme-inner-inner .readme-title{
	position: absolute;
	background-color: #fff;
	top:0;
	left:0;
	font-size: 10px;
	padding: 0 5px;
	border: 1px solid #ccc;
	border-top: none;
	border-left: none;
    -webkit-border-radius: 5px 0px 5px 0px;
       -moz-border-radius: 5px 0px 5px 0px;
            border-radius: 5px 0px 5px 0px;
}
//-->
</style>
</head>
<body>
	<div id="wrapper">
		<div id="main">
			<div class="roundbox">
				<h4>File Viewer</h4>
			</div>

			<!-- mainView -->
			<div id="mainView" class="roundbox">
				<ul>
					<li>
						<a class="dirOpen" href="#">+</a>
						<a class="dirClose" href="#">-</a>
						<span class="fileName">./</span>
					</li>
				</ul>
			</div>

		</div><!-- main -->
	</div><!-- wrapper -->
</body>
</html>
